import hu.elte.geometry.Circle;
import hu.elte.geometry.Point;
import hu.elte.image.Canvas;

import java.awt.Color;
import java.io.IOException;

public class Circles {

    public static void main(String[] args) throws IOException {
        if (args.length < 1) {
            throw new IllegalArgumentException("there is no first argument which should point to the out image file name");
        }
        String outImage = args[0];
        String[] circleAttributes = new String[args.length - 1];
        System.arraycopy(/*forras*/ args, /*forrasban melyik kezdo poziciotol*/ 1, /*hova*/ circleAttributes, /*azon belul honnantol*/ 0,/*es milyen hosszan*/ args.length - 1);
        /* az elobbi egyszerubben (viszont kell java.util.Arrays-t importolni):
        String[] circleAttributes = Arrays.copyOfRange(args, 1, args.length);
        */

        Circle[] circles = createCircles(circleAttributes);

        try (Canvas canvas = new Canvas(200, 200)) {
            for (Circle circle : circles) {
                canvas.draw(circle, Color.MAGENTA);
            }
            canvas.saveToPng(outImage);
        }
    }

    private static Circle[] createCircles(String[] args) {
        if (args.length % 3 != 0) {
            throw new IllegalArgumentException("circles must be represented by triples of x and y coordinates and the radius, number of parameters is " + args.length);
        }

        int numberOfCircles = args.length / 3;
        Circle[] circles = new Circle[numberOfCircles];
        for (int i = 0; i < args.length; i+=3) {
            double x = Double.parseDouble(args[i]);
            double y = Double.parseDouble(args[i + 1]);
            double r = Double.parseDouble(args[i + 2]);
            circles[i / 3] = new Circle(new Point(x, y), r);
        }

        return circles;
    }

}